<?php

namespace FM\Service;

use FM\Factory\GerenciamentoChkFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\LogTransfergerchkService;

class GerenciamentoChkService {

    protected $connection;
    protected $GerenciamentoChkFactory;
    protected $Environment;
    protected $newCode;
    protected $LogTransfergerchkService;

    public function __construct (EntityManager $entityManager, LogTransfergerchkService $LogTransfergerchkService, GerenciamentoChkFactory $GerenciamentoChkFactory, Environment $Environment, NewCode $newCode) {
        $this->connection = $entityManager->getConnection();
        $this->GerenciamentoChkFactory = $GerenciamentoChkFactory;
        $this->LogTransfergerchkService = $LogTransfergerchkService;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function listInspectionTask($param){
        $params = "";
        if($param["uni"] != "null"){
            $params .= " AND FCM_LOCALCLI.NRLOCALCLIENTEPAI in (SELECT FCM_LOCALCLI.NRLOCALCLIENTE FROM FCM_LOCALCLI
            WHERE FCM_LOCALCLI.NRLOCALCLIENTEPAI = ".$param["uni"].")";
        }
        if($param["loc"] != "null"){
            $params .= " AND FCM_CHECKLISTAGEND.NRLOCALCLIENTE = ".$param["loc"];
        }
        if($param["sec"] != "null"){  
            $params .= " AND FCM_LOCALCLI.NRSETOR = ".$param["sec"];
        }
        if($param["lct"] != "null"){
            $params .= " AND FCM_CHECKLISTAGEND.NRCHECKLIST IN (SELECT FCM_ATIVIDADECHK.NRCHECKLIST
            FROM FCM_ATIVIDADECHK
           WHERE FCM_ATIVIDADECHK.NRATIVIDADE = ".$param["lct"].")";
        }
        if($param["tst"] != "null"){
            $params .= " AND FCM_LOCALCLI.NRTIPOLOCALCLI = ".$param["tst"];
        }
        $operadores = $this->GerenciamentoChkFactory->listInspectionTask(array(
            "startPeriod"    => $param['start'],
            "finishPeriod"   => $param['finish'],
            "nr" => intval($param['nr'])
        ),$params);
        return $operadores;
    }

    public function transferVistoria($param){
        $this->connection->beginTransaction();
        
        try {
            $this->GerenciamentoChkFactory->transferVistoria(array(
                "nr" => intval($param['funcionarioDestino']),
                "list" => implode(",", $param['idVistoria'])
            ));
            
            foreach($param['idVistoria'] as $id){
                $dadosHistorico = $this->GerenciamentoChkFactory->dadosVistoria($id);
                $dadosHistorico = $dadosHistorico[0];
                $dadosHistorico['funcionarioOrigem'] = $param['funcionarioOrigem'];
                $dadosHistorico['funcionarioDestino'] = $param['funcionarioDestino'];
                $dadosHistorico['operadorTransfer'] = $param['operadorTransfer'];
                $this->LogTransfergerchkService->insertLogTrasnfer($dadosHistorico);
            }

            $this->connection->commit();

            $status = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $status = "ERROR";
        }
        
        return $status;
    }
    
    public function innerJoinChecklist($params) {
        $gerenciamentoChks = $this->GerenciamentoChkFactory->gerenciamentoChkInnerJoinChecklist($params);
        return $gerenciamentoChks;
    }
    
    public function updateVistoria($params) {
        $updatedValues = $this->GerenciamentoChkFactory->updateVistoria($params);
        return $updatedValues;
    }
}

?>