<?php

namespace FM\Service;

use FM\Factory\LogtransfAgendFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class LogtransfAgendService {

    protected $LogtransfAgendFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, LogtransfAgendFactory $LogtransfAgendFactory, Environment $Environment, NewCode $newCode) {
        $this->connection = $entityManager->getConnection();
        $this->LogtransfAgendFactory = $LogtransfAgendFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function insertLogTrasnfer($param){
        $this->connection->beginTransaction();
        
        try {
            $NRLOGTRANSFAGEND = $this->newCode->getCodeByTableName("FCM_LOGTRANSFAGEND",  $this->Environment->getNrOrg(), 1, 10, true);
             $this->LogtransfAgendFactory->insertLogTrasnfer(array(
                'NRLOGTRANSFAGEND' => $NRLOGTRANSFAGEND,
                'NRCHECKLISTAGEND' => $param["NRCHECKLISTAGEND"],
                'NRFUNCIONARIOORIGEM' => $param["funcionarioOrigem"],
                'DTHORAAGENDORIG' => substr($param['DTHORAAGEND'],0,-3),
                'NRFUNCIONARIODESTINO' => $param['funcionarioDestino'],
                'DTHORAAGENDDESTINO' => substr($param['DTHORAAGEND'],0,-3),
                'NRFUNCREALIZATRANSF' => intval($param['operadorTransfer']),
                'NRORG' =>  $this->Environment->getNrOrg()
            ));

            $this->connection->commit();

            $status = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $status = "ERROR";
        }
        
        return $status;
    }

    public function getHistorico(){
        $operadores = $this->LogtransfAgendFactory->getHistorico();
        $dadosFormatado = array();
        return $operadores;
    }
}

?>