CREATE OR REPLACE FUNCTION ARQUIVO_DPI_PRINCIPAL(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDINSCESTA   IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CONTADOR     IN NUMBER,
   P_SEQMAGNET    IN VARCHAR)
RETURN NUMBER
AS
   V_CONTADOR      NUMBER;
   V_CDIMPOSTRIB   VARCHAR2(2);
   V_REGISTRO_1    VARCHAR2(25);
   V_REGISTRO_2    VARCHAR2(25);
   V_COUNT         NUMBER;
   V_ALIQUOTA      VARCHAR2(25);
BEGIN
   V_CONTADOR := NVL(P_CONTADOR,0);
   V_COUNT    := 0;

   /* IMPOSTO COM SUBSTITUIO TRIBUTRIA */
   V_CDIMPOSTRIB := '80';

   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
      ('7'||LPAD(V_CONTADOR, 9, '0'),'300~',P_SEQMAGNET);

   BEGIN
      SELECT SUM(CASE WHEN (I.VRITEMMAPR +R.VRNORMDEBI) - R.VRNORMCRED > 0 THEN (I.VRITEMMAPR +R.VRNORMDEBI) - R.VRNORMCRED ELSE 0 END)
        INTO V_REGISTRO_1
        FROM MAPAAPURAC M, MAPARECUP R, ITMAPARECUP I
       WHERE M.CDEMPRESA     = P_CDEMPRESA
         AND M.CDINSCESTA    = P_CDINSCESTA
         AND M.CDIMPOSTO     = P_CDIMPOSTO
         AND M.DTINIPERIODO >= P_DTINICIAL
         AND M.DTFIMPERIODO <= P_DTFINAL
         AND M.NRSEQUMAPAPU  = R.NRSEQUMAPAPU
         AND R.NRSEQUMAPAPU  = I.NRSEQUMAPAPU
         AND I.IDTIPOITMAPR  = 'DA';
   EXCEPTION WHEN NO_DATA_FOUND THEN
      V_REGISTRO_1 := '0';
   END;

   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
      ('7'||LPAD(V_CONTADOR, 9, '0'),V_REGISTRO_1||'~',P_SEQMAGNET);

   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
      ('7'||LPAD(V_CONTADOR, 9, '0'),'0~',P_SEQMAGNET);


   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
      ('7'||LPAD(V_CONTADOR, 9, '0'),'0~',P_SEQMAGNET);

   V_COUNT := 0;
   WHILE (V_COUNT < 34) LOOP
      V_CONTADOR := NVL(V_CONTADOR,0)+1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
         ('7'||LPAD(V_CONTADOR, 9, '0'),'0~',P_SEQMAGNET);
         V_COUNT := V_COUNT + 1;
   END LOOP;
RETURN (LPAD(V_CONTADOR, 10, 0));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DPI_PRINCIPAL','5.30.000'); END;
/

