-- ====================================================================
--                 PROCEDIMENTO PARA POSIO DE ESTOQUE
--                 ------------ ---- ------- -- -------
--
--  PARMETROS: P_FILIAL     = CDIGO DA FILIAL A SER CONSIDERADA.          (IN)
--  ----------  P_PRODUTO    = PRODUTO A SER ATUALIZADO.                    (IN)
--              P_ALMOXARIFE = CDIGO DO ALMOXARIFADO A SER CONSIDERADO.    (IN)
--              P_LOCALESTOQ = CDIGO DO LOCAL DE ESTOQUE A SER CONSIDERADO.(IN)
--              P_NRLOTEESTQ = NMERO DO LOTE                               (IN)
--              P_NRSUBLOTE  = NMERO DO SUB-LOTE                           (IN)
--              P_QTDEESTO   = QUANTIDADE EM ESTOQUE.                       (OUT)
--
-- @C:\WIN_PRJ\SQL\SQLSERVER\0002_GERSTP_POSICAO_ESTOQUE_ATUAL.SQL
--
-- Manutenes:
-- 19/10/2001 - Ana Paula da Silva - Converso para SqlServer 
-- ====================================================================

IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'POSICAO_ESTOQUE_ATUAL' AND
              TYPE = 'P' 		                 AND
              U.UID = O.UID                    AND
              U.NAME = USER)

DROP PROCEDURE POSICAO_ESTOQUE_ATUAL
GO

CREATE PROCEDURE POSICAO_ESTOQUE_ATUAL
   @P_FILIAL     VARCHAR(04),
   @P_PRODUTO    VARCHAR(10),
   @P_ALMOXARIFE VARCHAR(06),
   @P_LOCALESTOQ VARCHAR(06),
   @P_NRLOTEESTQ VARCHAR(20),
   @P_NRSUBLOTE  VARCHAR(04),
   @P_QTDEESTO   NUMERIC OUTPUT
AS
   DECLARE @V_QTDEESTO NUMERIC;
   DECLARE @V_QTDEANTE NUMERIC;
BEGIN
   SELECT @V_QTDEESTO = ISNULL(ROUND(SUM(QTTOTALESTOQ),5),0)
   FROM POSESTATU
   WHERE (CDFILIAL      = @P_FILIAL)     AND
         (CDPRODUTO     = @P_PRODUTO)    AND
         ((CDALMOXARIFE = @P_ALMOXARIFE) OR (@P_ALMOXARIFE = 'T')) AND
         ((CDLOCALESTOQ = @P_LOCALESTOQ) OR (@P_LOCALESTOQ = 'T')) AND
         ((NRLOTEESTQ   = @P_NRLOTEESTQ) OR (@P_NRLOTEESTQ = 'T')) AND
         ((NRSUBLOTE    = @P_NRSUBLOTE ) OR (@P_NRSUBLOTE  = 'T'));
   SET @P_QTDEESTO = @V_QTDEESTO;
END;
GO
